/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Contreras
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.ccm.deploytool;

public class DeploymentProcess {

    private org.omg.CosNaming.NamingContext nc;
    private org.objectweb.ccm.descriptor.componentassembly.ComponentassemblyBean _assemblyObject;
    private Partition _partition;
    private Connector _connector;

    public DeploymentProcess (String[] args)
    throws Exception {

    // Init the ORB.
//	System.out.println("Initializing the ORB...");

    org.omg.CORBA.ORB orb
        = org.objectweb.ccm.Components.Runtime.init(args);

    // Obtain the Name Service.
//    System.out.println("Obtaining the Name Service...");
    org.omg.CORBA.Object obj =
            orb.resolve_initial_references("NameService");
    nc = org.omg.CosNaming.NamingContextHelper.narrow(obj);

    //getting the object from assembly descriptor
    java.io.File assemblyFile = new java.io.File (args[0]);
        _assemblyObject =
        org.objectweb.ccm.descriptor.componentassembly.ComponentassemblyImplBean.unmarshalBean(assemblyFile);

    //launching the operators
    _connector = new Connector(this);
    _partition = new Partition(this);
    }

    public Partition getPartition() {
    return this._partition;
    }

    public Connector getConnector() {
    return this._connector;
    }

    public org.objectweb.ccm.descriptor.componentassembly.ComponentassemblyBean getAssemblyObject() {
    return this._assemblyObject;
    }

    public org.omg.CosNaming.NamingContext getNc() {
    return this.nc;
    }

    private void operation()
    throws Exception {

    _partition.operate();

    System.out.println("switching the components to \"conf_complete\"");

    for (java.util.Enumeration enum = _partition.elements() ; enum.hasMoreElements() ; ) {
        ( (org.omg.Components.CCMObject) enum.nextElement() ).configuration_complete();
    }
    }

    public static void
    main(String[] args)
    throws Exception
    {
    DeploymentProcess processing = new DeploymentProcess(args);
    processing.operation();
        System.exit(0);
    }

}
